addhook("die", "inv_death")
function inv_death(id, src, wpn, hdmg, admg)
	if (inv_loseitems["death"] == nil) then
		return
	elseif (inv_loseitems["death"] == "drop") then
		for iid, item in pairs(inv[id]["items"]) do
			if (item["name"] == "None") then
				iid = iid
			else
				spawnitem(item, player(id, "tilex"), player(id, "tiley"))
			end
		end
	elseif (inv_loseitems["death"] == "delete") then
		inv[id] = nil
	end
end

addhook("endround", "inv_endround")
function inv_endround(mode)
	if (inv_loseitems["endround"] == nil) then
		return
	elseif (inv_loseitems["endround"] == "delete") then
		for id=1,32 do
			inv[id] = nil
		end
	elseif (inv_loseitems["endround"] == "drop") then
		for id=1,32 do
			for iid, item in pairs(inv[id]["items"]) do
				if (item["name"] == "None") then
					iid = iid
				else
					spawnitem(item, player(id, "tilex"), player(id, "tiley"))
				end
			end
		end
	end
end

addhook("spawn", "inv_spawn")
function inv_spawn(id)
	if (inv[id] == nil) then
		inv[id] = {}
		inv_hud[id] = true
		inv[id]["cur"] = 1
		inv[id]["combine"] = {}
		inv[id]["combine"][1] = 0
		inv[id]["combine"][2] = 0
		inv[id]["weight"] = 0
		inv[id]["items"] = {}
		inv[id]["items"][1] = {}
		inv[id]["items"][1]["use"] = none
		inv[id]["items"][1]["name"] = "None"
		inv[id]["items"][1]["desc"] = "Does nothing"
		inv[id]["items"][1]["amount"] = 1
		inv[id]["items"][1]["stacksize"] = 1
		inv[id]["items"][1]["weight"] = 0
		inv[id]["items"][1]["icon"] = "gfx/sprites/block.bmp"
		if (inv[id]["items"][inv[id]["cur"]]["amount"] > 1) then
			if (inv_hud[id] == true) then
				parse("hudtxt2 "..id.." "..inv_hud["id"]..' "'..inv[id]["items"][inv[id]["cur"]]["name"].." x"..inv[id]["items"][inv[id]["cur"]]["amount"]..'" '..inv_hud["x"].." "..inv_hud["y"].." 0")
			else
				msg2(id, "#"..inv[id]["cur"] - 1 ..": "..inv[id]["items"][inv[id]["cur"]]["name"].." x"..inv[id]["items"][inv[id]["cur"]]["amount"] .." - "..inv[id]["items"][inv[id]["cur"]]["desc"])
			end
		else
			if (inv_hud[id] == true) then
				parse("hudtxt2 "..id.." "..inv_hud["id"]..' "'..inv[id]["items"][inv[id]["cur"]]["name"]..'" '..inv_hud["x"].." "..inv_hud["y"].." 0")
			else
				msg2(id, "#"..inv[id]["cur"] - 1 ..": "..inv[id]["items"][inv[id]["cur"]]["name"].." - "..inv[id]["items"][inv[id]["cur"]]["desc"])
			end
		end
	end
end

function update_hud(id)
	if (inv[id]["items"][inv[id]["cur"]]["amount"] > 1) then
		if (inv_hud[id] == true) then
			parse("hudtxt2 "..id.." "..inv_hud["id"]..' "'..inv[id]["items"][inv[id]["cur"]]["name"].." x"..inv[id]["items"][inv[id]["cur"]]["amount"]..'" '..inv_hud["x"].." "..inv_hud["y"].." 0")
		else
			msg2(id, "#"..inv[id]["cur"] - 1 ..": "..inv[id]["items"][inv[id]["cur"]]["name"].." x"..inv[id]["items"][inv[id]["cur"]]["amount"] .." - "..inv[id]["items"][inv[id]["cur"]]["desc"])
		end
	else
		if (inv_hud[id] == true) then
			parse("hudtxt2 "..id.." "..inv_hud["id"]..' "'..inv[id]["items"][inv[id]["cur"]]["name"]..'" '..inv_hud["x"].." "..inv_hud["y"].." 0")
		else
			msg2(id, "#"..inv[id]["cur"] - 1 ..": "..inv[id]["items"][inv[id]["cur"]]["name"].." - "..inv[id]["items"][inv[id]["cur"]]["desc"])
		end
	end
end

addhook("say", "inv_cmds")
function inv_cmds(id, txt)
	if (txt == "!inv_next") then
		inv[id]["cur"] = inv[id]["cur"] + 1
		if (inv[id]["cur"] > #inv[id]["items"]) then
			inv[id]["cur"] = 1
		end
		update_hud(id)
		return 1
	elseif (txt == "!inv_prev") then
		inv[id]["cur"] = inv[id]["cur"] - 1
		if (inv[id]["cur"] < 1) then
			inv[id]["cur"] = #inv[id]["items"]
		end
		update_hud(id)
		return 1
	elseif (txt == "!inv_use") then
		inv[id]["items"][inv[id]["cur"]]["use"](id)
		while (inv[id]["cur"] > #inv[id]["items"]) do
			inv[id]["cur"] = inv[id]["cur"] - 1
		end
		update_hud(id)
		return 1
	elseif (txt == "!inv_combine") then
		if (inv[id]["cur"] == 1) then
			msg2(id, "Can't combine something with nothing!")
		elseif (inv[id]["combine"][1] == 0) then
			inv[id]["combine"][1] = inv[id]["items"][inv[id]["cur"]]
			msg2(id, "What do you want to combine "..inv[id]["combine"][1]["name"].." with?")
		else
			inv[id]["combine"][2] = inv[id]["items"][inv[id]["cur"]]
			if ((inv[id]["combine"][1]["combine"] == nil) and (inv[id]["combine"][2]["combine"] == nil)) then
				msg2(id, "Failed to combine - "..inv[id]["combine"][1]["name"].." with "..inv[id]["combine"][2]["name"])
			elseif (inv[id]["combine"][1]["combine"] == inv[id]["combine"][2]["name"]) then
				removeitem(id, inv[id]["combine"][1])
				removeitem(id, inv[id]["combine"][2])
				giveitem(id, inv[id]["combine"][1]["result"])
				msg2(id, "Gained "..inv[id]["combine"][1]["result"].."!")
				while (inv[id]["cur"] > #inv[id]["items"]) do
					inv[id]["cur"] = inv[id]["cur"] - 1
				end
				update_hud(id)
			elseif (inv[id]["combine"][2]["combine"] == inv[id]["combine"][1]["name"]) then
				removeitem(id, inv[id]["combine"][1])
				removeitem(id, inv[id]["combine"][2])
				giveitem(id, inv[id]["combine"][2]["result"])
				msg2(id, "Gained "..inv[id]["combine"][2]["result"].."!")
				while (inv[id]["cur"] > #inv[id]["items"]) do
					inv[id]["cur"] = inv[id]["cur"] - 1
				end
				update_hud(id)
			else
				msg2(id, "Failed to combine - "..inv[id]["combine"][1]["name"].." with "..inv[id]["combine"][2]["name"])
			end
			inv[id]["combine"][1] = 0
			inv[id]["combine"][2] = 0
		end
		return 1
	elseif (txt == "!inv_list") then
		for iid,item in pairs(inv[id]["items"]) do
			if (iid == 0) then
				iid = 0
			else
				if (item["amount"] > 1) then
					if (inv_maxtype == "weight") then
						msg2(id, "#"..iid - 1 ..": "..item["name"].." x"..item["amount"].." - "..item["desc"].." Wg: "..item["weight"] * item["amount"].." ("..item["weight"]..")")
					else
						msg2(id, "#"..iid - 1 ..": "..item["name"].." x"..item["amount"].." - "..item["desc"])
					end
				else
					if (inv_maxtype == "weight") then
						msg2(id, "#"..iid - 1 ..": "..item["name"].." - "..item["desc"].." Wg: "..item["weight"])
					else
						msg2(id, "#"..iid - 1 ..": "..item["name"].." - "..item["desc"])
					end
				end
			end
		end
		if (inv_maxtype == "weight") then
			msg2(id, "Total weight: "..inv[id]["weight"])
		elseif (inv_maxtype == "amount") then
			msg2(id, "Item slots taken: "..#inv[id]["items"] - 1)
		end
		return 1
	elseif (txt == "!inv_pickup") then
		local founditem = false
		for iid, item in pairs(inv_dropped) do
			if ((item["x"] == player(id, "tilex")) and (item["y"] == player(id, "tiley"))) then
				founditem = true
				pick(id, item)
			end
		end
		update_hud(id)
		if (founditem == false) then
			msg2(id, "There's nothing to pick here.")
		end
		return 1
	elseif (txt == "!inv_drop") then
		if (inv[id]["cur"] > 1) then
			inv[id]["weight"] = inv[id]["weight"] - inv[id]["items"][inv[id]["cur"]]["weight"]
			spawnitem(inv[id]["items"][inv[id]["cur"]]["name"], player(id, "tilex"), player(id, "tiley"))
			removeitem(id, inv[id]["items"][inv[id]["cur"]], 1)
		end
		while (inv[id]["cur"] > #inv[id]["items"]) do
			inv[id]["cur"] = inv[id]["cur"] - 1
		end
		update_hud(id)
		return 1
	elseif (txt == "!inv_hud") then
		if (inv_hud[id] == true) then
			inv_hud[id] = false
			parse("hudtxt2 "..id.." "..inv_hud["id"])
			msg2(id, "HUD inventory display is now disabled.")
		else
			inv_hud[id] = true
			update_hud(id)
			msg2(id, "HUD inventory display is now enabled.")
		end
		return 1
	elseif (txt == "!inv_desc") then
		msg2(id, inv[id]["items"][inv[id]["cur"]]["desc"])
		return 1
	elseif (txt == "!inv_longdesc") then
		if (inv[id]["items"][inv[id]["cur"]]["longdesc"]) then
			if (inv_maxtype == "weight") then
				msg2(id, inv[id]["items"][inv[id]["cur"]]["longdesc"].." Wg:"..inv[id]["items"][inv[id]["cur"]]["weight"])
			else
				msg2(id, inv[id]["items"][inv[id]["cur"]]["longdesc"])
			end
		else
			if (inv_maxtype == "weight") then
				msg2(id, inv[id]["items"][inv[id]["cur"]]["desc"].." Wg:"..inv[id]["items"][inv[id]["cur"]]["weight"])
			else
				msg2(id, inv[id]["items"][inv[id]["cur"]]["desc"])
			end
		end
		return 1
	end
end

function spawnitem(item, x, y, rot)
	if (rot == nil) then
		rot = math.random(-179, 180)
	end
	for iid, dropped in pairs(inv_dropped) do
		if ((dropped["x"] == x) and (dropped["y"] == y) and (item == dropped["name"])) then
			if (dropped["spec"] == nil) then
				if (dropped["amount"] < dropped["stacksize"]) then
					dropped["amount"] = dropped["amount"] + 1
					return iid
				end
			end
		end
	end
	newitem = loop_table(inv_items[item])
	newitem["x"] = x
	newitem["y"] = y
	newitem["image"] = image(newitem["icon"], newitem["x"] * 32 + 16, newitem["y"] * 32 + 16, 0)
	imagepos(newitem["image"], newitem["x"] * 32 + 16, newitem["y"] * 32 + 16, rot)
	inv_dropped[#inv_dropped + 1] = newitem
	return #inv_dropped
end

function pick(id, item)
	if ((type(item) == "string") or (type(item) == "number")) then
		item = inv_dropped[tonumber(item)]
	end
	local pickable = check_weight(id, item)
	if (pickable == false) then
		msg2(id, "You can't pick up "..item["name"].."!")
	else
		if (item["stacksize"] < 2) then
			item["x"] = nil
			item["y"] = nil
			freeimage(item["image"])
			item["image"] = nil
			inv[id]["items"][#inv[id]["items"] + 1] = item
			inv[id]["weight"] = inv[id]["weight"] + (item["amount"] * item["weight"])
			table.remove(inv_dropped[iid])
			msg2(id, "Picked "..item["name"])
			return 1
		else
			local picked = 0
			if (item["spec"]) then
				for iid2, item2 in pairs(inv[id]["items"]) do
					if (picked == pickable) then
						msg2(id, "Picked "..item["name"].." x"..pickable)
						item["x"] = nil
						item["y"] = nil
						freeimage(item["image"])
						item["image"] = nil
						table.remove(inv_dropped[finddropped(item)])
						return 1
					elseif (item2["spec"]) then
						if ((item2["amount"] < item2["stacksize"]) and (item2["name"] == item["name"]) and (item2["spec"] == item["spec"])) then
							if (pickable - picked <= item2["stacksize"] - item2["amount"]) then
								item2["amount"] = item2["stacksize"]
								msg2(id, "Picked "..item["name"].." x"..pickable)
								item["x"] = nil
								item["y"] = nil
								freeimage(item["image"])
								item["image"] = nil
								table.remove(inv_dropped[finddropped(item)])
								return 1
							else
								picked = picked + item2["stacksize"] - item2["amount"]
								item2["amount"] = item2["stacksize"]
							end
						end
					end
				end
			else
				for iid2, item2 in pairs(inv[id]["items"]) do
					if (picked == pickable) then
						msg2(id, "Picked "..item["name"].." x"..pickable)
						return 1
					elseif (item2["spec"] == nil) then
						if ((item2["amount"] < item2["stacksize"]) and (item2["name"] == item["name"])) then
							if (pickable - picked <= item2["stacksize"] - item2["amount"]) then
								item2["amount"] = item2["amount"] + pickable
								msg2(id, "Picked "..item["name"].." x"..pickable)
								item["x"] = nil
								item["y"] = nil
								freeimage(item["image"])
								item["image"] = nil
								table.remove(inv_dropped[finddropped(item)])
								return 1
							else
								picked = picked + item2["stacksize"] - item2["amount"]
								item2["amount"] = item2["stacksize"]
							end
						end
					end
				end
			end
			if (picked < pickable) then
				item["amount"] = pickable - picked
				item["x"] = nil
				item["y"] = nil
				freeimage(item["image"])
				item["image"] = nil
				inv[id]["items"][#inv[id]["items"] + 1] = item
				inv[id]["weight"] = inv[id]["weight"] + (item["amount"] * item["weight"])
				table.remove(inv_dropped[finddropped(item)])
				msg2(id, "Picked "..item["name"].." x"..pickable)
				return 1
			end
		end
	end
end

function giveitem(id, item, spec)
	if (spec == nil) then
		if (inv_items[item]["stacksize"] > 1) then
			local gave = 0
			for iid, value in pairs(inv[id]["items"]) do
				if (amount > 0) then
					if (value["name"] == item) then
						if (value["amount"] == value["stacksize"]) then
							iid = iid
						else
							inv[id]["items"][iid]["amount"] = inv[id]["items"][iid]["amount"] + 1
							amount = amount - 1
							break
						end
					end
				else
					break
				end
			end
			if (amount > 0) then
				inv[id]["items"][#inv[id]["items"] + 1] = loop_table(inv_items[item])
				inv[id]["items"][#inv[id]["items"]]["amount"] = amount
			end
		else
			inv[id]["items"][#inv[id]["items"] + 1] = loop_table(inv_items[item])
		end
	else
		for iid, value in pairs(inv[id]["items"]) do
			if (amount > 0) then
				if (value["name"] == item) then
					if (value["amount"] == value["stacksize"]) then
						iid = iid
					elseif (value[specname] == spec) then
						inv[id]["items"][iid]["amount"] = inv[id]["items"][iid]["amount"] + 1
						amount = amount - 1
						break
					end
				end
			else
				break
			end
		end
		if (amount > 0) then
			inv[id]["items"][#inv[id]["items"] + 1] = inv_items[item]
			inv[id]["items"][#inv[id]["items"]]["amount"] = amount
			inv[id]["items"][#inv[id]["items"]]["spec"] = spec
		end
	end
	return #inv[id]["items"]
end

function removeitem(id, itemtable, amount)
	if (amount == nil) then
		amount = 1
	end
	if (itemtable["amount"] <= amount) then
		local iid = finditem(id, itemtable)
		table.remove(inv[id]["items"], iid)
		return true
	else
		itemtable["amount"] = itemtable["amount"] - amount
		return itemtable["amount"]
	end
end

function removedropped(iid, amount)
	if (amount == nil) then
		amount = 1
	end
	if (type(iid) == "table") then
		iid = finddropped(iid)
	end
	freeimage(inv_dropped[iid]["image"])
	if (inv_dropped[iid]["amount"] <= amount) then
		table.remove(inv_dropped[iid])
		return true
	else
		inv_dropped[iid]["amount"] = inv_dropped[iid]["amount"] - amount
		return inv_dropped[iid]["amount"]
	end
end

function finditem(id, itemtable)
	if (type(itemtable) == "string") then
		itemtable = inv_items[itemtable]
	end
	for iid, item in pairs(inv[id]["items"]) do
		if (item == itemtable) then
			return iid
		end
	end
	print("Error: Couldn't find item.")
	return nil
end

function finddropped(itemtable)
	for iid, item in pairs(inv_dropped) do
		if (item == itemtable) then
			return iid
		end
	end
	print("Error: Couldn't find item.")
	return nil
end

function loop_table(thistable)
	local result = {}
	for name, value in pairs(thistable) do
		if (type(value) == "table") then
			result[name] = loop_table(value)
		else
			result[name] = value
		end
	end
	return result
end

addhook("startround", "convert_items")
function convert_items(mode)
	local result = {}
	if (#item(0, "table") < #inv_items) then
		for iid2, value2 in pairs(inv_items) do
			for iid, value in pairs(item(0, "table")) do
				if ((item(iid, "exists")) and (item(iid, "name") == value2["name"])) then
					result[spawnitem(value2["name"], item(iid, "x"), item(iid, "y"))] = true
					parse("removeitem "..iid)
				end
			end
		end
	else
		for iid, value in pairs(item(0, "table")) do
			for iid2, value2 in pairs(inv_items) do
				if ((item(iid, "exists")) and (item(iid, "name") == value2["name"])) then
					result[spawnitem(value2["name"], item(iid, "x"), item(iid, "y"))] = true
					parse("removeitem "..iid)
				end
			end
		end
	end
	return result
end

function check_weight(id, item)
	if (inv_maxtype == "weight") then
		if (item["amount"] == 1) then 
			if (item["weight"] + inv[id]["weight"] > inv_max) then
				return false
			else
				return 1
			end
		else
			if (inv[id]["weight"] + item["weight"] > inv_max) then
				return false
			else
				local pickable = 0
				while (inv[id]["weight"] + pickable * item["weight"] <= inv_max) do
					pickable = pickable + 1
				end
				return pickable - 1
			end
		end
	elseif (inv_maxtype == "amount") then
		if (#inv[id]["items"] + 1 <= inv_max) then
			return item["amount"]
		elseif (item["stacksize"] == 1) then
			if (item["amount"] + #inv[id]["items"] > inv_max) then
				return false
			else
				return 1
			end
		else
			local pickable = 0
			if (item["spec"] == nil) then
				for iid, itemtable in pairs(inv[id]["items"]) do
					if ((itemtable["name"] == item["name"]) and (itemtable["spec"] == nil)) then
						pickable = pickable + itemtable["stacksize"] - itemtable["amount"]
					end
				end
				if (pickable >= item["amount"]) then
					return item["amount"]
				else
					return pickable
				end
			else
				for iid, itemtable in pairs(inv[id]["items"]) do
					if ((itemtable["name"] == item["name"]) and (itemtable["spec"] == item["spec"])) then
						pickable = pickable + itemtable["stacksize"] - itemtable["amount"]
					end
				end
				if (pickable >= item["amount"]) then
					return item["amount"]
				else
					return pickable
				end
			end
		end
	end
end

function none(id)
	return
end
